/********************************************************************
*   DrvErrors.h
*
*   Macintosh driver error message handlers.
*
*   Copyright (c) 1995-1997, Willows Software Inc.  All rights reserved.
*
********************************************************************/
#ifndef DrvErrors__h
#define DrvErrors__h

/* Error codes */
#define SYSERR_DISPLAY		1	/* error connecting to server */
#define SYSERR_SERVER		2	/* fatal error w/ server      */
#define SYSERR_XIO				3	/* fatal i/o error w/ server  */
#define SYSERR_MEMORY		4	/* fatal error memory allocation */
#define SYSERR_CONNECT		5	/* error connecting to server */
#define CONNECTSTR "No Display Server\nMust set DISPLAY environment variable\n"

/* Error handling routines */
short AlertMsg(char *msg, short kind);
void ErrMsgCode(Str255 msg, short code);
void ErrMsg(Str255 msg);
void SystemError(UINT action, DWORD errorcode, DWORD wParam, DWORD lParam);

#define KEEP_GOING 			1			/* Dialog items in COMPLEXALERT_ID */
#define DEBUGGER 			2
#define EXITTOSHELL 		3
#define STOPALERT			EXITTOSHELL
#define CAUTIONALERT		DEBUGGER
#define NOTEALERT			KEEP_GOING



#endif    /*  DrvErrors__h   */
